/* ttfmod.cpp                                                         */
/*TrueTypec[iȈՔŁj                                */

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mem.h>
#include "libtype.h"
#include "ttfmod.h"
#include "util.h"
#include <vector.h>

static char appClassName[]="ttfmod";
static char NOPWindowClassName[]="NOPWindow";
static char gaspWindowClassName[]="gaspWindow";
static char OS2WindowClassName[]="OS2Window";

char str[1024];
DWORD dummy;

OTF *otf=NULL;
static unsigned char *buf=NULL; // t@CۂƊi[

LRESULT CALLBACK wProc1(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK NOPProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK gaspProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK gaspDialogProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK OS2Proc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK aboutDialogProc(HWND,UINT,WPARAM,LPARAM);

/**********************************************************************
                          EChENXo^
**********************************************************************/

BOOL initMyApp(void){
  WNDCLASSEX wndc;
  HINSTANCE hInst=GetModuleHandle(NULL);

  //CEChE
  wndc.cbSize=sizeof(wndc);
  wndc.style=CS_HREDRAW|CS_VREDRAW;
  wndc.lpfnWndProc=wProc1;
  wndc.cbClsExtra=0;
  wndc.cbWndExtra=0;
  wndc.hInstance=hInst;
  wndc.hIcon=LoadIcon(hInst,"IDI_ICON2");
  wndc.hCursor=LoadCursor(NULL,IDC_ARROW);
  wndc.hbrBackground=NULL;//(HBRUSH)COLOR_WINDOW;
  wndc.lpszMenuName="MENU1";
  wndc.lpszClassName=appClassName;
  wndc.hIconSm=(HICON)LoadImage(hInst,MAKEINTRESOURCE(IDI_ICON2)
                                ,IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
  if(RegisterClassEx(&wndc)!=0){
    //ȂEChE
    wndc.lpfnWndProc=NOPProc;
    wndc.hIcon=NULL;
    wndc.hbrBackground=(HBRUSH)COLOR_WINDOW;
    wndc.lpszMenuName=NULL;
    wndc.lpszClassName=NOPWindowClassName;
    wndc.hIconSm=NULL;
    if(RegisterClassEx(&wndc)!=0){
      //gaspEChE
      wndc.lpfnWndProc=gaspProc;
      wndc.hbrBackground=(HBRUSH)COLOR_WINDOW;
      wndc.lpszMenuName=NULL;
      wndc.lpszClassName=gaspWindowClassName;
      if(RegisterClassEx(&wndc)!=0){
        //OS/2EChE
        wndc.lpfnWndProc=OS2Proc;
        wndc.lpszClassName=OS2WindowClassName;
        return RegisterClassEx(&wndc);
      }else
        return 0;
    }else
      return 0;
  }else
    return 0;
}

/**********************************************************************
                         CEChE̍쐬
**********************************************************************/

HWND initInstance(int nCmdShow){
  HWND hwnd;
  HINSTANCE hInst=GetModuleHandle(NULL);
  
  hwnd=CreateWindow(appClassName,"ttfmod - TrueType modifier",
                    WS_OVERLAPPEDWINDOW,
                    CW_USEDEFAULT,
                    CW_USEDEFAULT,
                    CW_USEDEFAULT,
                    CW_USEDEFAULT,
                    NULL,
                    NULL,
                    hInst,
                    NULL);
  if(!hwnd)
    return hwnd;

  ShowWindow(hwnd,nCmdShow);
  UpdateWindow(hwnd);
  return hwnd;
}

DWORD openOTFFile(LPCTSTR fname,unsigned char * &buf,OTF * &otf){
  HANDLE infile;
  DWORD filesize,dummy;

  infile=CreateFile(fname,
                    GENERIC_READ|GENERIC_WRITE,
                    0,
                    0,
                    OPEN_EXISTING,
                    FILE_ATTRIBUTE_ARCHIVE,
                    NULL);
  if(infile==(HANDLE)-1)
    return 0;

  // OTFIuWFNg̍쐬
  filesize=GetFileSize(infile,NULL);
  buf=new unsigned char[filesize];
  ReadFile(infile,buf,filesize,&dummy,NULL);
  otf=new OTF(buf);
  CloseHandle(infile);

  return filesize;
}

BOOL closeOTFFile(unsigned char * &buf,OTF * &otf){
  if(buf!=NULL){
    delete [] buf;
    buf=NULL;
  }
  if(otf!=NULL){
    delete otf;
    otf=NULL;
  }
  return TRUE;
}

bool writeUpdatedOTFFile(const char *filename,DWORD filesize,unsigned char *buf,OTF *otf){
  HANDLE outfile;
  DWORD dummy;

  if(otf==NULL)
    return false;

  otf->updateImage(buf);

  outfile=CreateFile(filename,
                     GENERIC_READ|GENERIC_WRITE,
                     0,
                     0,
                     CREATE_ALWAYS,
                     FILE_ATTRIBUTE_ARCHIVE,
                     NULL);
  if(outfile==NULL)
    return false;

  WriteFile(outfile,buf,/*otf->getImageSize()*/filesize,&dummy,NULL);
  CloseHandle(outfile);

  return true;
}

/**********************************************************************

**********************************************************************/

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
                   LPSTR lpszCmdLine,int nCmdShow){
  int ac;
  LPWSTR *av;
  char filepath[MAX_PATH];

  HWND hwnd;
  MSG msg;

  // OTFNXg߂̏
  initializeOTF();

  if(!initMyApp())
    return FALSE;
  if(!(hwnd=initInstance(nCmdShow)))
    return FALSE;

  // R}hC΃t@CJ
  av=CommandLineToArgvW(GetCommandLineW(),&ac);
  if(ac==2){
    wsprintf(filepath,"%ls",av[1]);
    PostMessage(hwnd,WM_COMMAND,IDX_OPENFILE,(LPARAM)filepath);
  }

  while(GetMessage(&msg,NULL,0,0)){
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }

  closeOTFFile(buf,otf);
  if(av!=NULL)
    LocalFree(LocalHandle(av));

  return (msg.wParam);
}

/**********************************************************************
                           c[r[
**********************************************************************/

void initTree(HWND hwnd,LPCTSTR path){
  HTREEITEM item1=NULL,item2=NULL;
  TV_INSERTSTRUCT tv;
  fontObject *fO;
  int i;

  TreeView_DeleteAllItems(hwnd);

  memset((char *)&tv,'\0',sizeof(tv));
  tv.hInsertAfter=TVI_ROOT;
  tv.item.mask=TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE;
  tv.item.iImage=tv.item.iSelectedImage=0;
  tv.hParent=NULL;
  tv.item.pszText=(TCHAR *)getFilename(path);
  item1=TreeView_InsertItem(hwnd,&tv);

  tv.item.iImage=tv.item.iSelectedImage=1;
  tv.hInsertAfter=TVI_LAST;
  tv.hParent=item1;
  for(i=0;i<numtags;i++){
    if(otf->findTable(tags[i],fO)==true){
      tv.item.pszText=(TCHAR *)tags[i];
      item2=TreeView_InsertItem(hwnd,&tv);
    }
  }
  return;
}

/**********************************************************************
                               \؊
**********************************************************************/

void changeMainView(HWND parent,HWND &hwnd,LPCTSTR tag){
  HINSTANCE hInst=GetModuleHandle(NULL);

  if(hwnd!=NULL){
    DestroyWindow(hwnd);
    hwnd=NULL;
  }

  for(int i=0; i<numtags; i++){
    if(strcmp(tags[i],tag)==0){
      switch(i){
      case  6: //OS/2
        hwnd=CreateWindowEx(WS_EX_CLIENTEDGE,
                            OS2WindowClassName,
                            "",
                            WS_CHILD|WS_VISIBLE,
                            0,0,0,0,
                            parent,
                            NULL,
                            hInst,
                            NULL);
        break;
      case 26: //gasp
        hwnd=CreateWindowEx(WS_EX_CLIENTEDGE,
                            gaspWindowClassName,
                            "",
                            WS_CHILD|WS_VISIBLE,
                            0,0,0,0,
                            parent,
                            NULL,
                            hInst,
                            NULL);
        break;
      default:
        hwnd=CreateWindowEx(WS_EX_CLIENTEDGE,
                            NOPWindowClassName,
                            "",
                            WS_CHILD|WS_VISIBLE,
                            0,0,0,0,
                            parent,
                            NULL,
                            hInst,
                            NULL);
      }
      break;
    }else
      hwnd=CreateWindowEx(WS_EX_CLIENTEDGE,
                          NOPWindowClassName,
                          "",
                          WS_CHILD|WS_VISIBLE,
                          0,0,0,0,
                          parent,
                          NULL,
                          hInst,
                          NULL);
  }
  return;
}

/**********************************************************************
                        gaspݒ͈͂̃XgXV
**********************************************************************/

void initGaspRangeList(HWND hwnd_list,map<unsigned short,unsigned short> &r){
  int i;
  map<unsigned short,unsigned short>::iterator ir;
  LV_ITEM lvitem;

  ListView_DeleteAllItems(hwnd_list);
  for(i=0,ir=r.begin(); ir!=r.end(); i++,++ir){
    if((*ir).first==GASP_INFINITY)
      sprintf(str,"");
    else
      sprintf(str,"%d",(*ir).first);
    lvitem.mask=LVIF_TEXT;
    lvitem.pszText=str;
    lvitem.iItem=i;
    lvitem.iSubItem=0;
    ListView_InsertItem(hwnd_list,&lvitem);

    if((*ir).first!=GASP_INFINITY)
      sprintf(str,"%d",(int)((*ir).first*.75)); //0.75=ʉ𑜓x96dpiƂꍇPPEMW
    lvitem.pszText=str;
    lvitem.iSubItem=1;
    ListView_SetItem(hwnd_list,&lvitem);
    lvitem.pszText=(TCHAR *)(((*ir).second&GASP_GRIDFIT)!=0?"":"Ȃ");
    lvitem.iSubItem=2;
    ListView_SetItem(hwnd_list,&lvitem);
    lvitem.pszText=(TCHAR *)(((*ir).second&GASP_DOGRAY)!=0?"":"Ȃ");
    lvitem.iSubItem=3;
    ListView_SetItem(hwnd_list,&lvitem);
  }
}

/**********************************************************************
                     gaspݒEChEvV[W
**********************************************************************/

LRESULT CALLBACK gaspProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
  HINSTANCE hInst=GetModuleHandle(NULL);
  static HWND hwnd_list;
  LV_COLUMN lvcolumn;
  int i;

  gaspHeader *g;
  map<unsigned short,unsigned short>::iterator ig;

  switch(msg){
  case WM_CREATE:
    hwnd_list=CreateWindowEx(WS_EX_CLIENTEDGE,
                             WC_LISTVIEW,
                             "",
                             WS_CHILD|WS_VISIBLE|LVS_REPORT|LVS_SINGLESEL|LVS_NOSORTHEADER,
                             0,0,0,0,
                             hwnd,
                             (HMENU)ID_GASP,
                             hInst,
                             NULL);
    ListView_SetExtendedListViewStyle(hwnd_list,
                                      ListView_GetExtendedListViewStyle(hwnd_list)|LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_HEADERDRAGDROP);

    lvcolumn.mask=LVCF_FMT|LVCF_WIDTH|LVCF_TEXT|LVCF_SUBITEM;
    lvcolumn.fmt=LVCFMT_LEFT;
    lvcolumn.cx=90;
    lvcolumn.pszText="TCYiPPEMj";
    lvcolumn.iSubItem=0;
    ListView_InsertColumn(hwnd_list,0,&lvcolumn);

    lvcolumn.cx=90;
    lvcolumn.pszText="TCYiPtj";
    lvcolumn.iSubItem=1;
    ListView_InsertColumn(hwnd_list,1,&lvcolumn);
    lvcolumn.cx=80;
    lvcolumn.pszText="qeBO";
    lvcolumn.iSubItem=2;
    ListView_InsertColumn(hwnd_list,2,&lvcolumn);
    lvcolumn.cx=80;
    lvcolumn.pszText="X[WO";
    lvcolumn.iSubItem=3;
    ListView_InsertColumn(hwnd_list,3,&lvcolumn);

    otf->findTable("gasp",(fontObject *)g);
    initGaspRangeList(hwnd_list,g->ranges);
    break;
  case WM_NOTIFY:
    NM_LISTVIEW *info;
    info=(NM_LISTVIEW *)lparam;
    switch(wparam){
    case ID_GASP:
      if(info->hdr.code==NM_DBLCLK && info->iItem!=-1){
        otf->findTable("gasp",(fontObject *)g);
        for(i=0,ig=g->ranges.begin(); i<info->iItem; i++,++ig);
        i=DialogBoxParam(hInst,"GASPSETTINGDLG",hwnd,(DLGPROC)gaspDialogProc,MAKELPARAM((*ig).first,(*ig).second));
        if(i!=-1){
          if(LOWORD(i)!=(*ig).first && g->ranges.find(LOWORD(i))!=g->ranges.end())
            MessageBox(hwnd,"͂ꂽ͈͕͂ʂɓo^Ă܂B","Error",MB_OK|MB_ICONSTOP);
          else{
            g->ranges.erase(ig);
            g->ranges[LOWORD(i)]=HIWORD(i);
            initGaspRangeList(hwnd_list,g->ranges);
            UpdateWindow(hwnd_list);
          }
        }
      }
      break;
    }
    break;
  case WM_SIZE:
    MoveWindow(hwnd_list,16,80,MAKEPOINTS(lparam).x-32,MAKEPOINTS(lparam).y-96,TRUE);
    break;
  default:
    return DefWindowProc(hwnd, msg, wparam, lparam);
  }
  return 0;
}

/**********************************************************************
                     gaspݒ_CAOvV[W
**********************************************************************/

LRESULT CALLBACK gaspDialogProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam){
  static unsigned short oldPPEM;
  unsigned short m;
  unsigned int n;
  
  switch(msg){
  case WM_INITDIALOG:
    oldPPEM=LOWORD(lparam);
    if(oldPPEM==0xffff){
      SetDlgItemText(hwnd,IDC_EDIT,"");
      EnableWindow(GetDlgItem(hwnd,IDC_EDIT),false);
      EnableWindow(GetDlgItem(hwnd,IDC_RADIO1),false);
      EnableWindow(GetDlgItem(hwnd,IDC_RADIO2),false);
    }else{
      SetDlgItemInt(hwnd,IDC_EDIT,oldPPEM, false);
      Button_SetCheck(GetDlgItem(hwnd,IDC_RADIO1),true); // PPEMɃ`FbN
      Button_SetCheck(GetDlgItem(hwnd,IDC_RADIO2),false);
    }
    Button_SetCheck(GetDlgItem(hwnd,IDC_CHECK1),(HIWORD(lparam)&GASP_GRIDFIT)!=0);
    Button_SetCheck(GetDlgItem(hwnd,IDC_CHECK2),(HIWORD(lparam)&GASP_DOGRAY)!=0);
    break;
  case WM_COMMAND:
    switch(LOWORD(wparam)){
    case IDOK:
      n=GetDlgItemInt(hwnd,IDC_EDIT,NULL,false);
      if(n>GASP_INFINITY-1 || (n==0 && oldPPEM!=GASP_INFINITY))
        MessageBox(hwnd,"TCY̒l܂B\n0ł̂łӂB","Error",MB_OK|MB_ICONSTOP);
      else{
        n=(oldPPEM==GASP_INFINITY) ? GASP_INFINITY : (Button_GetCheck(GetDlgItem(hwnd,IDC_RADIO2))==true ? ceil(n/.75) : n);
        m=(Button_GetCheck(GetDlgItem(hwnd,IDC_CHECK1))==true)?GASP_GRIDFIT:0;
        m|=(Button_GetCheck(GetDlgItem(hwnd,IDC_CHECK2))==true)?GASP_DOGRAY:0;
        EndDialog(hwnd,MAKELONG((unsigned short)n,m));
      }
      break;
    case IDCANCEL:
      EndDialog(hwnd,-1);
      break;
    default:
      return FALSE;
    }
  default:
    return FALSE;
  }
  return TRUE;
}

/**********************************************************************
                     OS/2ݒEChEvV[W
**********************************************************************/

LRESULT CALLBACK OS2Proc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
  HINSTANCE hInst=GetModuleHandle(NULL);
  static HWND hwnd_combo1, hwnd_combo2, hwnd_edit1, hwnd_static1, hwnd_track1, hwnd_static2, hwnd_track2;
  static map<HWND,unsigned short> hwnd_check1;
  map<HWND,unsigned short>::iterator ihc1;
  HWND hwnd_temp;

  static HFONT hfont;
  int i;

  static OS2 *o;
  fsTypeID_type::iterator ift;
  fsTypeOptionID_type::iterator ifto;
  panWeightID_type::iterator ipw;

  switch(msg){
  case WM_CREATE:
    hfont=CreateFont(12,0,0,0,
                     FW_NORMAL,
                     FALSE,
                     FALSE,
                     FALSE,
                     SHIFTJIS_CHARSET,
                     OUT_DEFAULT_PRECIS,
                     CLIP_DEFAULT_PRECIS,
                     PROOF_QUALITY,
                     VARIABLE_PITCH|FF_DONTCARE,
                     "lr oSVbN");
    //////// fsType
    hwnd_temp=CreateWindow("STATIC",
                           "ߍ݋ԁF",
                           WS_CHILD|WS_VISIBLE|SS_LEFTNOWORDWRAP,
                           16,16+4,108,12,
                           hwnd,
                           NULL,
                           hInst,
                           NULL);
    SendMessage(hwnd_temp,WM_SETFONT,(WPARAM)hfont,0);
    hwnd_combo1=CreateWindow("COMBOBOX",
                             "",
                             WS_CHILD|WS_VISIBLE|CBS_DROPDOWNLIST,
                             16+108+16,16,144,100,
                             hwnd,
                             NULL,
                             hInst,
                             NULL);
    SendMessage(hwnd_combo1,WM_SETFONT,(WPARAM)hfont,0);

    otf->findTable("OS/2",(fontObject *)o);

    for(ift=fsTypeID.begin(); ift!=fsTypeID.end(); ++ift){
      sprintf(str,"%s",(*ift).first);
      i=ComboBox_AddString(hwnd_combo1,str);
      ComboBox_SetItemData(hwnd_combo1,i,(*ift).second);
      if((o->fsType&0x00ff)==(*ift).second)
        ComboBox_SetCurSel(hwnd_combo1,i);
    }
#ifdef RESTRICTED_VERSION
    EnableWindow(hwnd_combo1,false);
#endif

    for(i=0,ifto=fsTypeOptionID.begin(); ifto!=fsTypeOptionID.end(); i++,++ifto){
      sprintf(str,"%s",(*ifto).first);
      hwnd_temp=CreateWindow("BUTTON",
                             str,
                             WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX,
                             16,16+20+20*i,144,20,
                             hwnd,
                             NULL,
                             hInst,
                             NULL);
      SendMessage(hwnd_temp,WM_SETFONT,(WPARAM)hfont,0);
      Button_SetCheck(hwnd_temp,(o->fsType&(*ifto).second));
#ifdef RESTRICTED_VERSION
      EnableWindow(hwnd_temp,false);
#endif
      hwnd_check1[hwnd_temp]=(*ifto).second;
    }
    //////// achVendID
    hwnd_temp=CreateWindow("STATIC",
                           "x_[IDF",
                           WS_CHILD|WS_VISIBLE|SS_LEFTNOWORDWRAP,
                           300,16+4,96,12,
                           hwnd,
                           NULL,
                           hInst,
                           NULL);
    SendMessage(hwnd_temp,WM_SETFONT,(WPARAM)hfont,0);
    hwnd_edit1=CreateWindowEx(WS_EX_CLIENTEDGE,
                              "EDIT",
                              "",
                              WS_CHILD|WS_VISIBLE,
                              370,16,64,16,
                              hwnd,
                              NULL,
                              hInst,
                              NULL);
    SendMessage(hwnd_edit1,WM_SETFONT,(WPARAM)hfont,0);
    Edit_LimitText(hwnd_edit1,4);
    memcpy(str,o->achVendID,4);
    str[4]='\0';
    Edit_SetText(hwnd_edit1,str);
#ifdef RESTRICTED_VERSION
    EnableWindow(hwnd_edit1,false);
#endif
    //////// usWeightClass
    hwnd_temp=CreateWindow("STATIC",
                           "EGCgF",
                           WS_CHILD|WS_VISIBLE|SS_LEFTNOWORDWRAP,
                           300,16+20+4,96,12,
                           hwnd,
                           NULL,
                           hInst,
                           NULL);
    SendMessage(hwnd_temp,WM_SETFONT,(WPARAM)hfont,0);
    hwnd_track1=CreateWindow(TRACKBAR_CLASS,
                             "",
                             WS_CHILD|WS_VISIBLE|TBS_AUTOTICKS,
                             300,16+20*2,144,20,
                             hwnd,NULL,
                             hInst,
                             NULL);
    SendMessage(hwnd_track1,WM_SETFONT,(WPARAM)hfont,0);
    SendMessage(hwnd_track1,TBM_SETRANGEMIN,(WPARAM)false,(LPARAM)1);
    SendMessage(hwnd_track1,TBM_SETRANGEMAX,(WPARAM)false,(LPARAM)9);
    SendMessage(hwnd_track1,TBM_SETTICFREQ,(WPARAM)1,(LPARAM)true);
    SendMessage(hwnd_track1,TBM_SETPOS,(WPARAM)true,(LPARAM)o->usWeightClass/100);
    hwnd_static1=CreateWindow("STATIC",
                              "",
                              WS_CHILD|WS_VISIBLE|SS_LEFTNOWORDWRAP,
                              450,16+20*2+4,96,12,
                              hwnd,
                              NULL,
                              hInst,
                              NULL);
    SendMessage(hwnd_static1,WM_SETFONT,(WPARAM)hfont,0);
    Static_SetText(hwnd_static1,usWeightClassID[o->usWeightClass]);
    // usWidthClass
    hwnd_temp=CreateWindow("STATIC",
                           "F",
                           WS_CHILD|WS_VISIBLE|SS_LEFTNOWORDWRAP,
                           300,16+20*3+4,96,12,
                           hwnd,
                           NULL,
                           hInst,
                           NULL);
    SendMessage(hwnd_temp,WM_SETFONT,(WPARAM)hfont,0);
    hwnd_track2=CreateWindow(TRACKBAR_CLASS,
                             "",
                             WS_CHILD|WS_VISIBLE|TBS_AUTOTICKS,
                             300,16+20*4,144,20,
                             hwnd,NULL,
                             hInst,
                             NULL);
    SendMessage(hwnd_track2,WM_SETFONT,(WPARAM)hfont,0);
    SendMessage(hwnd_track2,TBM_SETRANGEMIN,(WPARAM)false,(LPARAM)1);
    SendMessage(hwnd_track2,TBM_SETRANGEMAX,(WPARAM)false,(LPARAM)9);
    SendMessage(hwnd_track2,TBM_SETTICFREQ,(WPARAM)1,(LPARAM)true);
    SendMessage(hwnd_track2,TBM_SETPOS,(WPARAM)true,(LPARAM)o->usWidthClass);
    hwnd_static2=CreateWindow("STATIC",
                              "",
                              WS_CHILD|WS_VISIBLE|SS_LEFTNOWORDWRAP,
                              450,16+20*4+4,96,12,
                              hwnd,
                              NULL,
                              hInst,
                              NULL);
    SendMessage(hwnd_static2,WM_SETFONT,(WPARAM)hfont,0);
    Static_SetText(hwnd_static2,usWidthClassID[o->usWidthClass]);
    //////// panose.bWeight
    hwnd_temp=CreateWindow("STATIC",
                           "EGCgiPANOSEjF",
                           WS_CHILD|WS_VISIBLE|SS_LEFTNOWORDWRAP,
                           16,16+20*10+4,108,12,
                           hwnd,
                           NULL,
                           hInst,
                           NULL);
    SendMessage(hwnd_temp,WM_SETFONT,(WPARAM)hfont,0);
    hwnd_combo2=CreateWindow("COMBOBOX",
                             "",
                             WS_CHILD|WS_VSCROLL|WS_VISIBLE|CBS_DROPDOWNLIST,
                             16+108+16,16+20*10,144,100,
                             hwnd,
                             NULL,
                             hInst,
                             NULL);
    SendMessage(hwnd_combo2,WM_SETFONT,(WPARAM)hfont,0);

    for(ipw=panWeightID.begin(); ipw!=panWeightID.end(); ++ipw){
      sprintf(str,"%s",(*ipw).second);
      i=ComboBox_AddString(hwnd_combo2,str);
      ComboBox_SetItemData(hwnd_combo2,i,(*ipw).first);
      if(o->panose.bWeight==(*ipw).first)
        ComboBox_SetCurSel(hwnd_combo2,i);
    }
    break;

  case WM_COMMAND:
    switch(HIWORD(wparam)){
    case CBN_SELCHANGE:
      if((HWND)lparam==hwnd_combo1){
#ifndef RESTRICTED_VERSION
        o->fsType=ComboBox_GetItemData((HWND)lparam,ComboBox_GetCurSel((HWND)lparam));
        for(ihc1=hwnd_check1.begin(); ihc1!=hwnd_check1.end(); ++ihc1){
          if(Button_GetCheck((*ihc1).first))
            o->fsType|=(*ihc1).second;
        }
#endif
      }else
        o->panose.bWeight=ComboBox_GetItemData((HWND)lparam,ComboBox_GetCurSel((HWND)lparam));
      break;
    case BN_CLICKED:
#ifndef RESTRICTED_VERSION
      o->fsType^=hwnd_check1[(HWND)lparam];
#endif
      break;
    case EN_CHANGE:
#ifndef RESTRICTED_VERSION
      Edit_GetText(hwnd_edit1,str,5);
      memcpy(o->achVendID,str,4);
#endif
      break;
    }
    break;

  case WM_HSCROLL:
    if((HWND)lparam==hwnd_track1){
      o->usWeightClass=SendMessage(hwnd_track1,TBM_GETPOS,0,0)*100;
      sprintf(str,"%s",usWeightClassID[o->usWeightClass]);
      Static_SetText(hwnd_static1,str);
    }else{ // hwnd_track2
      o->usWidthClass=SendMessage(hwnd_track2,TBM_GETPOS,0,0);
      sprintf(str,"%s",usWidthClassID[o->usWidthClass]);
      Static_SetText(hwnd_static2,str);
    }
    break;

  case WM_DESTROY:
    DeleteObject(hfont);

  default:
    return DefWindowProc(hwnd, msg, wparam, lparam);
  }
  return 0;
}

/**********************************************************************
                         ucɂāv{bNX
**********************************************************************/

LRESULT CALLBACK aboutDialogProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam){
  switch(msg){
  case WM_COMMAND:
    if(LOWORD(wparam)==IDOK){
      EndDialog(hwnd,IDOK);
      break;
    }
    return FALSE;
  default:
    return FALSE;
  }
}

/**********************************************************************
                    ȂEChEvV[W
**********************************************************************/

LRESULT CALLBACK NOPProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
  return DefWindowProc(hwnd, msg, wparam, lparam);
}

/**********************************************************************
                       yEChEvV[W
**********************************************************************/

LRESULT CALLBACK baseProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
  HINSTANCE hInst=GetModuleHandle(NULL);
  static int dMode=0; // 0:ĂȂ 1:{^ 2:hbO
  static HWND hwnd_tree=NULL,hwnd_main=NULL;
  static int splitPos,splitCurPos,splitOldPos;
  RECT rc;
  static int width,height;
  static HIMAGELIST hil;

  int i,j;
  
  switch(msg){
  case WM_LBUTTONDOWN:
    if(dMode==0){
      dMode=1;
      splitOldPos=-1;
      splitCurPos=splitPos;
      //o[oh`ɔAʑŜ̕`bN
      LockWindowUpdate(GetDesktopWindow());
      //}EẌʒuqEChȄォłE悤ɂ
      SetCapture(hwnd);
    }
    break;
  case WM_LBUTTONUP:
    if(dMode==2){
      dMode=0;
      //ʒu
      splitPos=MAKEPOINTS(lparam).x;
      if(splitPos<31)
        splitPos=31;
      else if(splitPos>width-31)
        splitPos=width-31;
      //o[oh
      drawSplitRubberBand(hwnd,splitCurPos);
      //o[oh`̂߂̃bN
      LockWindowUpdate(NULL);
      //Xvbgo[̍ĕ`
      //UpdateWindow(hwnd);
      //qEChE̕ʒuXV
      MoveWindow(hwnd_tree,0,-1,splitPos-1,height+2,TRUE);
      MoveWindow(hwnd_main,splitPos+1,0,width-splitPos-1,height,TRUE);
      //}EXLv`A]vȈʒuω擾Ȃ悤ɂ
      ReleaseCapture();
    }else if(dMode==1){
      dMode=0;
      ReleaseCapture();
    }
    break;
  case WM_MOUSEMOVE:
    if(dMode==1 || dMode==2){
      dMode=2;
      //Oɕ`o[oh
      if(splitOldPos!=-1)
        drawSplitRubberBand(hwnd,splitCurPos);
      //ʒuXV
      splitOldPos=splitCurPos;
      splitCurPos=MAKEPOINTS(lparam).x;
      if(splitCurPos<31)
        splitCurPos=31;
      else if(splitCurPos>width-31)
        splitCurPos=width-31;
      //VʒuɃo[oh`
      drawSplitRubberBand(hwnd,splitCurPos);
    }
    break;
  case WM_CREATE:
    //ftHg̕ʒu
    splitPos=150;
    hwnd_tree=CreateWindowEx(WS_EX_CLIENTEDGE,
                             WC_TREEVIEW,
                             "",
                             WS_CHILD|WS_VISIBLE|WS_BORDER|TVS_HASLINES|TVS_HASBUTTONS|TVS_LINESATROOT,
                             0,0,0,0,
                             hwnd,
                             (HMENU)ID_MYTREE,
                             GetModuleHandle(NULL),
                             NULL);
    hil=ImageList_Create(16,16,ILC_COLOR8|ILC_MASK,1,0);
    ImageList_AddIcon(hil,LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON2)));
    ImageList_AddIcon(hil,LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON3)));
    TreeView_SetImageList(hwnd_tree,hil,TVSIL_NORMAL);
    changeMainView(hwnd,hwnd_main,"");
    break;
  case WM_NOTIFY:
    TV_DISPINFO *info;
    TV_ITEM item;
    info=(TV_DISPINFO *)lparam;
    switch(wparam){
    case ID_MYTREE:
      if(info->hdr.code==TVN_SELCHANGED){
        item.hItem=TreeView_GetSelection(hwnd_tree);
        item.mask=TVIF_HANDLE|TVIF_TEXT;
        item.pszText=new char[MAX_PATH*2];
        item.cchTextMax=MAX_PATH*2;
        TreeView_GetItem(hwnd_tree,&item);
        changeMainView(hwnd,hwnd_main,item.pszText);
        MoveWindow(hwnd_main,splitPos+1,0,width-splitPos-1,height,TRUE);
        delete [] item.pszText;
      }
      break;
    }
    break;
  case WM_COMMAND:
    switch(LOWORD(wparam)){
    case IDX_INITTREE:
      initTree(hwnd_tree,(LPCTSTR)lparam);
      changeMainView(hwnd,hwnd_main,(LPCTSTR)lparam);
      MoveWindow(hwnd_main,splitPos+1,0,width-splitPos-1,height,TRUE);
      break;
    }
    break;
  case WM_ERASEBKGND:
    HDC dc;
    RECT rc;

    dc=(HDC)wparam;
    rc.left=splitPos-1;
    rc.right=rc.left+3;
    rc.top=0;
    rc.bottom=height;
    FillRect(dc,&rc,(HBRUSH)COLOR_WINDOW);
    return TRUE;
  case WM_SIZE:
    width=MAKEPOINTS(lparam).x;
    height=MAKEPOINTS(lparam).y;
    if(width>0 && splitPos>width-31)
      splitPos=width-31;
    MoveWindow(hwnd_tree,0,-1,splitPos-1,height+2,TRUE);
    MoveWindow(hwnd_main,splitPos+1,0,width-splitPos-1,height,TRUE);
    break;
  default:
    return (DefWindowProc(hwnd, msg, wparam, lparam));
  }
  return 0;
}

/**********************************************************************
                      CEChEvV[W
**********************************************************************/

LRESULT CALLBACK wProc1(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
  static DWORD filesize;
  HINSTANCE hInst=GetModuleHandle(NULL);
  WNDCLASSEX wndc;
  const char baseWindowClassName[]="ttfmodBaseWindow";
  static HWND hwnd_base,hwnd_sb;
  OPENFILENAME ofn;

  switch (msg){
  case WM_CREATE:
    InitCommonControls();
    /*x[XEChE̍쐬*/
    wndc.cbSize=sizeof(wndc);
    wndc.style=CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
    wndc.lpfnWndProc=baseProc;
    wndc.cbClsExtra=0;
    wndc.cbWndExtra=0;
    wndc.hInstance=hInst;
    wndc.hIcon=NULL;
    wndc.hCursor=LoadCursor(NULL,IDC_SIZEWE);
    wndc.hbrBackground=NULL;//(HBRUSH)COLOR_WINDOW;
    wndc.lpszMenuName=NULL;
    wndc.lpszClassName=baseWindowClassName;
    wndc.hIconSm=NULL;
    RegisterClassEx(&wndc);
    hwnd_base=CreateWindowEx(0,
                             baseWindowClassName,
                             "",
                             WS_CHILD|WS_VISIBLE,
                             0,0,0,0,
                             hwnd,
                             NULL,
                             hInst,
                             NULL);
    //j[̏
    //HMENU hmenu;
    //hmenu=GetMenu(hwnd);
    //EnableMenuItem(hmenu,IDM_OPEN,MF_GRAYED);
    //EnableMenuItem(hmenu,IDM_WRITE,MF_GRAYED);
    //EnableMenuItem(hmenu,IDM_ABOUT,MF_GRAYED);
    //Xe[^Xo[
    hwnd_sb=CreateStatusWindow(WS_CHILD|WS_VISIBLE|CCS_BOTTOM|SBARS_SIZEGRIP,
                               NULL,
                               hwnd,
                               ID_STATUS);
    break;
  case WM_COMMAND:
    switch(LOWORD(wparam)){
    case IDM_QUIT:
      SendMessage(hwnd,WM_CLOSE,0,0L);
      break;
    case IDM_OPEN:
      memset(&ofn,0,sizeof(ofn));
      ofn.lStructSize=sizeof(ofn);
      ofn.hwndOwner=hwnd;
      ofn.lpstrFilter="TrueType,OpenType(TrueTypeAEgC)(*.ttf)\0*.ttf\0OpenType(*.otf)\0*.otf\0ΉSẴtHg\0*.ttf;*.otf\0\0";
      ofn.lpstrFile=new char[MAX_PATH*2];
      ofn.nMaxFile=MAX_PATH*2;
      ofn.lpstrFile[0]='\0';
      ofn.lpstrFileTitle=new char[MAX_PATH*2];
      ofn.nMaxFileTitle=MAX_PATH*2;
      ofn.lpstrFileTitle[0]='\0';
      ofn.Flags=OFN_FILEMUSTEXIST;
      ofn.lpstrTitle="tHgt@CJ";
      ofn.lpstrDefExt="ttf";
      if(GetOpenFileName(&ofn)){
        closeOTFFile(buf,otf);
        SendMessage(hwnd,WM_COMMAND,IDX_OPENFILE,(LPARAM)ofn.lpstrFile);
      }
      delete [] ofn.lpstrFile;
      delete [] ofn.lpstrFileTitle;
      break;
    case IDM_WRITE:
      memset(&ofn,0,sizeof(ofn));
      ofn.lStructSize=sizeof(ofn);
      ofn.hwndOwner=hwnd;
      ofn.lpstrFilter="TrueType,OpenType(TrueTypeAEgC)(*.ttf)\0*.ttf\0OpenType(*.otf)\0*.otf\0ΉSẴtHg\0*.ttf;*.otf\0\0";
      ofn.lpstrFile=new char[MAX_PATH*2];
      ofn.nMaxFile=MAX_PATH*2;
      ofn.lpstrFile[0]='\0';
      ofn.lpstrFileTitle=new char[MAX_PATH*2];
      ofn.nMaxFileTitle=MAX_PATH*2;
      ofn.lpstrFileTitle[0]='\0';
      ofn.Flags=OFN_OVERWRITEPROMPT;
      ofn.lpstrTitle="tHgt@C̏o";
      ofn.lpstrDefExt="ttf";
      if(GetSaveFileName(&ofn))
        writeUpdatedOTFFile(ofn.lpstrFile,filesize,buf,otf);
      delete [] ofn.lpstrFile;
      delete [] ofn.lpstrFileTitle;
      break;
    case IDM_ABOUT:
      DialogBox(GetModuleHandle(NULL),"ABOUTBOX",
                hwnd,(DLGPROC)aboutDialogProc);
      break;
    case IDX_OPENFILE:
      SendMessage(hwnd_sb,SB_SETTEXT,0|0,(LPARAM)"t@Cǂݍł܂...");
      if((filesize=openOTFFile((LPCTSTR)lparam,buf,otf))!=0)
        SendMessage(hwnd_base,WM_COMMAND,IDX_INITTREE,lparam);
      else
        MessageBox(GetParent(hwnd),"t@CJƂł܂B","Error",MB_OK|MB_ICONSTOP);
      SendMessage(hwnd_sb,SB_SETTEXT,0|0,(LPARAM)"");
      break;
    }
    break;
  case WM_SIZE:
    RECT rc;
    SendMessage(hwnd_sb,WM_SIZE,wparam,lparam);
    GetClientRect(hwnd_sb,&rc);
    MoveWindow(hwnd_base,0,0,LOWORD(lparam),HIWORD(lparam)-rc.bottom,TRUE);
    break;
  case WM_DESTROY:
    PostQuitMessage(0);
    break;
  default:
    return (DefWindowProc(hwnd, msg, wparam, lparam));
  }
  return 0;
}
